#  S9418.defn.tcl

proc {Add_Silena S9418_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]
   set A24addrbase [second $addressinfo]
   set A32addrbase [third $addressinfo]
   set interruptlevel [fourth $addressinfo]
   set interruptvector [fifth $addressinfo]

   set CurrentVMEServer  $server
 
   define-vme-register $name xVME Test_Reg        "-a$A32addrbase -w32 -o0x40 -pwo -d16 -zx -i255"

   define-vme-register $name xVME Ctrl_Reg1       "-a$A32addrbase -w32 -o0x44 -prw -d16 -zx -i1"
   define-vme-register $name xVME Disable         "-a$A32addrbase -w32 -o0x44 -prw -d16 -l1 -b0 -zd"

   define-vme-register $name xVME TestPulse       "-a$A32addrbase -w32 -o0x46 -pwo -d16 -zx"

   define-vme-register $name xVME Vsn1            "-a$A32addrbase -w32 -o0x48 -prw -d16 -l8 -b0 -zx -i0"
   define-vme-register $name xVME Vsn2            "-a$A32addrbase -w32 -o0x4a -prw -d16 -l8 -b0 -zx -i0"

   define-vme-register $name xVME Ctrl_Reg2       "-a$A32addrbase -w32 -o0x4c -prw -d16 -zx -i1"

   define-vme-register $name xVME RTP             "-a$A32addrbase -w32 -o0x4e -prw -d16 -l5 -b0 -zx -i2"

   for {set i 0} {$i < 32} {incr i} {
      define-vme-register $name xVME Threshold$i  "-a$A32addrbase -w32 -o[expr $i * 2] -prw -d16 -l8 -b0 -zd -i16"
   }

   define-vme-register $name bVME FIFO            "-a[expr $A32addrbase + 0x100] -w32 -o0x0 -pro -d32 -zx -l64"
}

proc {Silena S9418_registers} {} {
    global registers_table

    set registers_table   {}

    for {set i 0} {$i < 32} {incr i} {
        lappend registers_table [list "Threshold Memory ch$i"  Threshold$i]
    }
}

proc {Silena S9418_DAQ-reset} {args} {
#   S9418
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#      Offline the module - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[write-vme-register $module.Ctrl_Reg1 1] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff
}

proc {Silena S9418_DAQ-go} {args} {
#   S9418
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    write-vme-register $module.Ctrl_Reg1 0
}

proc {Silena S9418_DAQ-halt} {args} {
#   S9418
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    write-vme-register $module.Ctrl_Reg1 1
}

proc {Silena S9418_DAQ-setup} {args} {
#   S9418
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
#    initialise
    write-vme-register $module.Ctrl_Reg1 1
    initialise-vme-registers $module.*
    write-vme-register $module.Ctrl_Reg1 1
    write-vme-register $module.Vsn2 [third $args]
}

#   for parameter save/restore
set {Silena S9418_registersavepatterns} {RTP Threshold*}


